typedef void (*FNPTR)();

int OnKey(int,FNPTR);
int OnKeyCancel(void);
int InKey(int);
int LastKey(void);
int PutKey(int);

#define INS			   	0x5200
#define HOME            0x4700
#define PGUP            0x4900
#define DEL          	0x5300
#define END             0x4F00
#define PGDN            0x5100

#define LEFT	   		0x4B00
#define RIGHT		   	0x4D00
#define UP              0x4800
#define DOWN            0x5000


#define TAB		   		0x0F09
#define BACKSPACE	   	0x0E08
#define ENTER           0x1C0D
#define ESC		         0x011B

#define F1             0x3B00
#define F2             0x3C00
#define F3             0x3D00
#define F4             0x3E00
#define F5             0x3F00
#define F6             0x4000
#define F7             0x4100
#define F8             0x4200
#define F9             0x4300
#define F10            0x4400
#define F11            0x8500
#define F12            0x8600

#define SHFT_F1        0x5400
#define SHFT_F2        0x5500
#define SHFT_F3        0x5600
#define SHFT_F4        0x5700
#define SHFT_F5        0x5800
#define SHFT_F6        0x5900
#define SHFT_F7        0x5A00
#define SHFT_F8        0x5B00
#define SHFT_F9        0x5C00
#define SHFT_F10       0x5D00
#define SHFT_F11       0x8700
#define SHFT_F12       0x8800

#define CTRL_F1        0x5E00
#define CTRL_F2        0x5F00
#define CTRL_F3        0x6000
#define CTRL_F4        0x6100
#define CTRL_F5        0x6200
#define CTRL_F6        0x6300
#define CTRL_F7        0x6400
#define CTRL_F8        0x6500
#define CTRL_F9        0x6600
#define CTRL_F10       0x6700
#define CTRL_F11       0x8900
#define CTRL_F12       0x8A00

#define ALT_F1         0x6800
#define ALT_F2         0x6900
#define ALT_F3         0x6A00
#define ALT_F4         0x6B00
#define ALT_F5         0x6C00
#define ALT_F6         0x6D00
#define ALT_F7         0x6E00
#define ALT_F8         0x6F00
#define ALT_F9         0x7000
#define ALT_F10        0x7100
#define ALT_F11        0x8B00
#define ALT_F12        0x8C00
